package uo.sdi.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import uo.sdi.acciones.*;

public class Controlador extends javax.servlet.http.HttpServlet {
	
	Map<String, Accion> mapaDeAcciones; // <opcion, objeto Accion>
	Map<String, Map<String, String>> mapaDeJSP; // <opcion, <resultado, JSP>>
	
	public void doGet(HttpServletRequest req, HttpServletResponse res)
				throws IOException, ServletException {
		
		String opcion, resultado, jspSiguiente;
		String opcionSiError="empezar";
		Accion accion;
		
		try {
			opcion=req.getParameter("opc");
				
			accion=buscarAccionParaOpcion(opcion);
				
			resultado=accion.execute(req,res);
				
			jspSiguiente=buscarJSPSegun(opcion, resultado);

		} catch(Exception e) {
			
			accion=buscarAccionParaOpcion(opcionSiError);
			
			resultado=accion.execute(req,res);
				
			jspSiguiente=buscarJSPSegun(opcionSiError, resultado);
		}
			
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(jspSiguiente); 
			
		dispatcher.forward(req, res);			
}			

	// Obtiene un objeto accion en funcin de la opcin
	// enviada desde el navegador
	Accion buscarAccionParaOpcion(String opcion) {
		
		return mapaDeAcciones.get(opcion);
	}
	
	
	// Obtiene la pgina JSP a la que habr que entregar el
	// control el funcin de la opcin enviada desde el navegador
	// y el resultado de la ejecucin de la accin asociada
	String buscarJSPSegun(String opcion, String resultado) {
		
		return mapaDeJSP.get(opcion).get(resultado);		
	}
		
		
	void crearMapaAcciones() {
		
		mapaDeAcciones=new HashMap<String,Accion>();
		
		mapaDeAcciones.put("elegir", new ElegirAction());
		mapaDeAcciones.put("pagar", new PagarAction());
		mapaDeAcciones.put("terminar", new TerminarAction());
		mapaDeAcciones.put("empezar", new EmpezarAction());		

	}
	
	
	void crearMapaDeJSP() {
				
		mapaDeJSP=new HashMap<String, Map<String, String>>();
		
		Map<String, String> resJSP=new HashMap<String, String>();
		resJSP.put("EXITO","/index.jsp");
		mapaDeJSP.put("elegir",resJSP);
		
		resJSP=new HashMap<String, String>();
		resJSP.put("EXITO","/tarjeta.jsp");
		resJSP.put("FRACASO","/index.jsp");
		mapaDeJSP.put("pagar",resJSP);
		
		resJSP=new HashMap<String, String>();
		resJSP.put("EXITO","/fin.jsp");
		resJSP.put("FRACASO","/tarjeta.jsp");
		mapaDeJSP.put("terminar",resJSP);
		
		resJSP=new HashMap<String, String>();
		resJSP.put("EXITO","/index.jsp");
		mapaDeJSP.put("empezar",resJSP);

	}
			
	public void init() throws ServletException {  
		crearMapaAcciones();
		crearMapaDeJSP();
    }
	
	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws IOException, ServletException {

		doGet(req, res);
	}

	}